import styled from 'styled-components';
import {Button, ButtonGroup, TextField} from "@mui/material";
import {useState} from "react";
import {connect} from "react-redux";
import {changeAuthData, changeAuthDataAsync} from "../store/actionCreators/ActionCreators"
import {useNavigate} from "react-router-dom";


const LogRegistrBlock = styled.div`
  max-width: 500px;
  max-height: 500px;
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  border: 1px solid grey;
  border-radius: 15px;
  min-height: 350px;
  min-width: 350px;
`
const StyledButtonSignIn = styled(Button)`
  color: ${(props) => props.authtype === "signIn" ? "red" : ""} !important;
`
const StyledButtonSignUp = styled(Button)`
  color: ${(props) => props.authtype === "signUp" ? "red" : ""} !important;
`


const Auth = (props) => {
    // console.log(props)
    const [authType, setAuthType] = useState("signIn")
    const [login, setLogin] = useState("")
    const [password, setPassword] = useState("")
    const navigate = useNavigate();



    const btnHandler = (type) => {
        setAuthType(type)
    }
    const inputLoginHandler = (e) => {
        setLogin(e.target.value)
    }
    const inputPasswordHandler = (e) => {
        setPassword(e.target.value)
    }

    const authBtnHandler =  () => {
        if(login && password){
        props.changeAuthDataAsync({login, password, authType, navigateCallback: navigate})

    }}


    return (
        <LogRegistrBlock>
            <ButtonGroup variant="text" aria-label="text button group">
                <StyledButtonSignIn authtype={authType} onClick={(e) => btnHandler("signIn")}>Sign
                    in</StyledButtonSignIn>
                <StyledButtonSignUp authtype={authType} onClick={(e) => btnHandler("signUp")}>Sing
                    up</StyledButtonSignUp>
            </ButtonGroup>
            {props.error && <p>{props.error}</p>}
            <TextField id="outlined-login" label="login" variant="outlined" onChange={inputLoginHandler}/>
            <TextField id="outlined-password" label="password" type="password" variant="outlined"
                       onChange={inputPasswordHandler}/>

            <Button disabled={!login || !password} onClick={authBtnHandler} variant="outlined">{authType === "signIn" ? "SIGN IN" : "SIGN UP"}</Button>
        </LogRegistrBlock>
    )
}

const mapStateToProps = (state) => {
    return {
        token: state.auth.token,
        error: state.error.auth,
    }
}

const mapDispatchToProps = (dispatch) => {
    return {
        changeAuthData: (authData) => dispatch(changeAuthData(authData)),
        changeAuthDataAsync: (authData) => dispatch(changeAuthDataAsync(authData))
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(Auth);


// const StyledInput = styled.input`
//   font-size: 20px;
//   border: 1px solid darkgray;
//   border-radius: 10px;
//   padding: 5px 20px;
//   ::placeholder {
//     color: darkgray;
//     font-size: 0.8em;
//   }
// `

// const StyledInputPassword = styled(StyledInput)`
//
// `