import {useEffect, useState} from "react";
import {gqlOnePost} from "../shared/services&utilits/gqlRequest";
import AvaLoginBlock from "./AvaLoginBlock";
import TimeOfCreation from "./TimeOfCreation";
import styled from 'styled-components';

const CommentsBlockStyled = styled.div`
  width: 100%;
  overflow: auto;
  height: 60%;
`
const AnswerWrap = styled.div`
  margin-left: 30px`

function CommentsBlock(props) {
    // console.log(props.id)
    const [postData, setPostData] = useState(null);

    useEffect(() => {
        if (!postData) {
            gqlOnePost(props.id).then(res => res.json())
                .then(data =>{
                    // !props.isLikesRendered && props.setLikes(data["data"].PostFindOne.likes)
                    setPostData(data["data"].PostFindOne);
                })
        }
    }, [])
    const Comment = ({commentData}) => {
        // console.log(commentData)

        return <>
            <AvaLoginBlock name={commentData.owner.login} urlAva={commentData.owner.avatar?.url}
                           styled={{height: "30px"}}/>
            <p>{commentData.text}</p>
            <TimeOfCreation createdTime={commentData.createdAt}/>
            {commentData.answers &&
            <AnswerWrap>
                <p>OTVET</p>
                {commentData.answers.map((item, i) => <Comment commentData={item} key={i}/>)}
            </AnswerWrap>
            }
        </>
    }
    console.log(postData)
    return (<CommentsBlockStyled>
            <div>комент</div>
            {postData && postData?.comments &&
            <>
                {postData.comments.map((item, i) => <Comment commentData={item} key={i}/>)}
            </>}
        </CommentsBlockStyled>
    )
}

export default CommentsBlock;