import styled from 'styled-components';

const ModalWindowWrapper = styled.div`
  position: fixed;
  z-index: 100;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background-color: rgba(0, 0, 0, 0.3);
  display: flex;
  justify-content: center;
  align-items: center;
`

const InnerWrapper = styled.div`
  width: 80%;
  height: 80%;
  background-color: white;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.5);
  border-radius: 10px;
  z-index: 101;
  display: flex;
  
`

function ModalWindow({children, closeModal}) {

    return (
        <ModalWindowWrapper onClick={() => closeModal()}>
            <InnerWrapper onClick={(e) => {
                e.stopPropagation()
            }}>
                {children}
            </InnerWrapper>
        </ModalWindowWrapper>
    )
}

export default ModalWindow;