import {Avatar} from '@mui/material';
import styled from 'styled-components';
import {connect} from "react-redux";
import {useEffect} from "react";
import {changeAuthData, changeAuthDataAsync, setUserDataAsync} from "../store/actionCreators/ActionCreators";
import {useNavigate} from "react-router-dom";
import avatar from "../assets/img/avatarGolub.jpg"

const HeaderWrapper = styled.div`
  display: flex;
  justify-content: space-evenly;
  box-shadow: 0px 10px 13px -7px #000000, 5px 5px 15px 5px rgba(41, 78, 255, 0);
`

const OwnerHeader = (props) => {
    const navigate = useNavigate();
    useEffect(() => {
        if (!props.ownerData) {
            props.setUserDataAsync(props.id, true)
        }

    })

    const Logo = () => {
        return (
            <p>HIPSTARGAM</p>
        )
    }
    const logout = () => {
        localStorage.authToken = "";
        props.changeAuthData({
            token: "",
            user: ""
        })
        navigate("/auth")

    }

    return (
        <HeaderWrapper>
            <button onClick={logout}>Logout</button>
            <Logo/>
            <p>Hello</p>
            <Avatar  src={props.ownerData && props.ownerData.avatar ? props.ownerData.avatar.url : avatar} alt={"avatar"} sx={{border:"1px solid grey"}}/>
        </HeaderWrapper>
    )
};

const mapStateToProps = (state) => {
    return {
        id: state.auth.user.sub.id,
        ownerData: state.ownerData,
    }
}
const mapDispatchToProps = (dispatch) => {
    return {
        changeAuthData: (authData) => dispatch(changeAuthData(authData)),
        changeAuthDataAsync: (authData) => dispatch(changeAuthDataAsync(authData)),
        setUserDataAsync: (id, isOwner) => dispatch(setUserDataAsync(id, isOwner)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(OwnerHeader);