import {gqlAboutUser, gqlLogin, gqlRegistration, gqlAllPosts} from "../../shared/services&utilits/gqlRequest";
import {jwtDecode} from "../../shared/services&utilits/utilits";

export const changeAuthData = authData => ({
    type: "CHANGE_AUTH_DATA",
    payload: authData
})

export const setError = error => ({
    type: "SET_ERROR",
    payload: error
})

export const changeAuthDataAsync = ({login, password, authType, navigateCallback}) => {
     return async (dispatch) => {
        let response = ""
        if (authType === "signUp") {
            response = await gqlRegistration(login, password)
            if (!response.ok) {
                dispatch(setError("Server is not answer"))
            }

            const responseData = await response.json();
            console.log(responseData)
            const user = responseData.data.createUser;
            console.log(user)
            if (user) {
                dispatch(changeAuthDataAsync({login, password, authType: "signIn", navigateCallback}))

            } else {
                dispatch(setError("Login is already exist"))
            }
        }
        if (authType === "signIn") {
            response = await gqlLogin(login, password)
            if (!response.ok) {
                dispatch(setError("Server is not answer"))
            }
            const responseData = await response.json();
            console.log(responseData)
            const token = responseData.data.login;
            if (jwtDecode(token)){
                localStorage.authToken = token
            }

            if (!token) {
                dispatch(setError("Wrong login or password"))
            } else {
                dispatch(changeAuthData({token: token, user: jwtDecode(token)}))
                dispatch(setError(null))
                navigateCallback("../profile")
            }
        }
    }
};

export const setUserDataAsync = (id, isOwner) => {

    return async (dispatch) => {
        let response = ""
            response = await gqlAboutUser(id)

            if (!response.ok) {
                dispatch(setError("No user data received"))
            }
            const responseData = await response.json();
            if(isOwner){
                dispatch(setOwnerData(responseData.data.UserFindOne))
            }else{
                dispatch(setActiveUserData(responseData.data.UserFindOne))
            }

        }
};

export const setActiveUserData =(data)=>({
    type: "SET_ACTIVE_USER_DATA",
    payload: data,
} )
export const setOwnerData =(data)=>({
    type: "SET_OWNER_DATA",
    payload: data,
} )
export const setActiveUserAllPostsAsync = (id)=>{
    return async(dispatch)=>{
        let response = ""
        response = await gqlAllPosts(id)

        // if (!response.ok) {
        //     dispatch(setError("No user data received"))
        // }

        const responseData = await response.json();
        dispatch(setActiveUserAllPosts(responseData.data.PostFind))
        console.log(responseData.data.PostFind)
    }
}

export const setActiveUserAllPosts =(data)=>({
    type: "SET_ACTIVE_USER_ALL_POSTS",
    payload: data,
})
